名前空間
変種
操作

std::bad_exception

提供: cppreference.com
< cpp‎ | error
 
 
 
エラー処理
例外処理
例外処理の失敗
bad_exception
(C++17未満)
(C++17未満)
(C++11)(C++17未満)
(C++17未満)
契約
 
 
ヘッダ <exception> で定義
class bad_exception;

std::bad_exception は以下の状況で C++ ランタイムによって投げられる例外の型です。

1) std::exception_ptr がキャッチされた例外のコピーを格納し、 std::current_exception によってキャッチされた例外オブジェクトのコピーコンストラクタが例外を投げた場合、キャプチャされる例外は std::bad_exception のインスタンスです。
2) 動的例外指定に違反し、 std::unexpected がその例外指定に違反する例外を投げたとき、その例外指定で std::bad_exception が許可されていれば、 std::bad_exception が投げられます。
(C++17未満)
cpp/error/exceptionstd-bad exception-inheritance.svg
画像の詳細

継承図

目次

[編集] メンバ関数

bad_exception オブジェクトを構築します
(パブリックメンバ関数)
オブジェクトをコピーします
(パブリックメンバ関数)
[仮想]
説明文字列を返します
(仮想パブリックメンバ関数)

std::exception から継承

メンバ関数

例外オブジェクトを破棄します
(std::exceptionの仮想パブリックメンバ関数) [edit]
[仮想]
説明文字列を返します
(std::exceptionの仮想パブリックメンバ関数) [edit]

[編集]

#include <iostream>
#include <exception>
#include <stdexcept>
 
void my_unexp() { throw; }
 
void test() throw(std::bad_exception)
{
    throw std::runtime_error("test");
}
 
int main()
{
    std::set_unexpected(my_unexp);
    try {
         test();
    } catch(const std::bad_exception& e)
    {
        std::cerr << "Caught " << e.what() << '\n';
    }
}

出力:

Caught std::bad_exception